#!/usr/bin/python

import re
import weather

#this maps bbc weather icons into widget icons
iconmap = {'0':'31', '1':'32', '2':'26', '3':'28', '4':'4', '5':'22',
        '6':'21', '7':'26', '8':'26', '9':'6', '10':'9', '11':'6', '12':'6',
        '13':'12', '14':'9', '15':'12', '16':'8', '17':'8', '18':'8', '19':'15',
        '20':'15', '21':'15', '22':'14', '23':'13', '24':'14', '25':'15',
        '26':'15', '27':'15', '28':'27', '29':'17', '30':'4', '31':'2', '32':'20',
        '100':'25'}

#'1':'31', '3':'27',
# '32':'31', '28':'27',
# Make sure we don't try to get any more than 5 day's forecast
file = open('test.html','r')
data = file.read()
# Chop the data into more managable size
start = data.find('<!-- global nav close -->')
stop = data.find('</body>')
data1 = data[start:stop]
p_lon_lat = r'Latitude</strong>:\s(?P<latitude>.+),<br\s/><strong>Longitude</strong>:\s(?P<longitude>.+)\.<br'
match = re.search(p_lon_lat, data1)
if match:
    longitude = match.group('longitude')
    latitude = match.group('latitude')
print 'long: ' + longitude
print 'lat: ' + latitude
# The regular expressions needed to get the weather forecast

# time and location of the weather report
now = weather.Observation()

print 'Searching for city'
p_city = r'<h1 style="text-transform:capitalize;">(?P<city>.+?),'
match = re.search(p_city, data1)
if match:
        match_city = match.group('city')
        now.place(match_city)
        print 'city matched: ' + match_city
#group = group.replace('&nbsp;', '')

print 'Searching for time info'
p_time = r'''(?ix)
Observed</strong>:\s
(?P<weekday>\w+)\s
(?P<day>\d+)/(?P<month>\d+)/(?P<year>\d+)\s 
at \s <br \s />
(?P<time>\d+)'''
match = re.search(p_time, data1)
if match:
    print 'time info matched'
    stormyear = match.group('year')
    stormmonth = match.group('month')
    stormday = match.group('day')
    now.year(match.group('year'))
    now.month(match.group('month'))
    now.day(match.group('day'))
    now.weekday(match.group('weekday'))
    now.time(match.group('time'))
    now.timezone('GMT')

#current observations
p_current =  r'''(?isx)
Nearest\sObservations
.*?<span\sstyle="text-transform:capitalize;">(?P<sky>.*)</span>\s(?P<temp>\d+?)<abbr
.*?C</abbr><br\s/>(?P<wind>[^\(]+)\s?\((?P<speed>.*)\s<abbr
.*?Relative\shumidity.*?</strong>:\s?(?P<hum>\d+),
.*?<strong>Pressure.*?</strong>:\s(?P<baro>.*?),\s(?P<change>.*?),<
.*?Visibility</strong>:\s(?P<vis>[^<]+)<
'''
match = re.search(p_current, data1)
print 'Checking for observation match'
if match:
    print 'Current observation matched'
    now.sky(match.group('sky'))
    print 'Sky: ' + now.sky()
    now.temperature(match.group('temp'))
    print 'Temperature: ' + now.temperature()
    now.wind_speed(match.group('speed'),'mph')
    print 'Windspeed: ' + now.wind_speed()
    now.wind(match.group('wind'))
    print 'Wind: ' + now.wind()
    now.humidity(match.group('hum'))
    print 'Humidity: ' + now.humidity()
    now.pressure(match.group('baro'))
    print 'Pressure: ' + now.pressure()
    now.pressure_change(match.group('change'))
    print 'Pressure Change: ' + now.pressure_change()
    now.visibility(match.group('vis'))
    print 'Visibility: ' + now.visibility()

# day today:

p_1day = r'''(?isx)
day \s one\s///////\s-->.*?<strong>(?P<day>.\w{2})
.*? strong&gt;(?P<desc>.*?)&lt;/strong
.*? fiveday_sym/(?P<icon>\d+).gif
.*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
.*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
.*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
'''
match = re.search(p_1day, data1)
if match:
    today = weather.Forecast(match.group('day'))
    now.add_forecast(today)
    today.icon(iconmap[match.group('icon')])
    today.sky(match.group('desc').replace('.',''))
    print 'today: icon: ' + match.group('icon') + ' description: ' + match.group('desc')
    today.temperature_high(match.group('max'))
    today.temperature_low(match.group('min'))
    today.wind_speed(match.group('speed'), 'mph')
    today.wind(match.group('wind'))
    today.visibility(match.group('visib'))
    today.pressure(match.group('pressu'))
    today.humidity(match.group('humidi'))

if len(now.forecasts) == 0:
        print "Can not parse forecast - today"

p_2day = r'''(?isx)
day \s two\s///////\s-->.*?<strong>(?P<day>.\w{2})
.*? strong&gt;(?P<desc>.*?)&lt;/strong
.*? fiveday_sym/(?P<icon>\d+).gif
.*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
.*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
.*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
'''
match = re.search(p_2day, data1)
if match:
    day1 = weather.Forecast(match.group('day'))
    now.add_forecast(day1)
    day1.icon(iconmap[match.group('icon')])
    day1.sky(match.group('desc').replace('.',''))
    print 'day1: icon: ' + match.group('icon') + ' description: ' + match.group('desc')
    day1.temperature_high(match.group('max'))
    day1.temperature_low(match.group('min'))
    day1.wind_speed(match.group('speed'), 'mph')
    day1.wind(match.group('wind'))
    day1.visibility(match.group('visib'))
    day1.pressure(match.group('pressu'))
    today.humidity(match.group('humidi'))

p_3day = r'''(?isx)
day \s three\s///////\s-->.*?<strong>(?P<day>.\w{2})
.*? strong&gt;(?P<desc>.*?)&lt;/strong
.*? fiveday_sym/(?P<icon>\d+).gif
.*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? "temptxt"><strong>(?P<min>[\d/-]+) <abbr \s title="Night
.*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
.*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
'''
match = re.search(p_3day, data1)
if match:
    day2 = weather.Forecast(match.group('day'))
    now.add_forecast(day2)
    day2.icon(iconmap[match.group('icon')])
    day2.sky(match.group('desc').replace('.',''))
    print 'day2: icon: ' + match.group('icon') + ' description: ' + match.group('desc')
    day2.temperature_high(match.group('max'))
    day2.temperature_low(match.group('min'))
    day2.wind_speed(match.group('speed'), 'mph')
    day2.wind(match.group('wind'))
    day2.visibility(match.group('visib'))
    day2.pressure(match.group('pressu'))
    day2.humidity(match.group('humidi'))

p_4day = r'''(?isx)
day \s four\s///////\s-->.*?<strong>(?P<day>.\w{2})
.*? strong&gt;(?P<desc>.*?)&lt;/strong
.*? fiveday_sym/(?P<icon>\d+).gif
.*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? <strong>(?P<min>[\d/-]+) <abbr \s title="Night
.*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
.*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
'''
match = re.search(p_4day, data1)
if match:
    day3 = weather.Forecast(match.group('day'))
    now.add_forecast(day3)
    day3.icon(iconmap[match.group('icon')])
    day3.sky(match.group('desc').replace('.',''))
    print 'day1: icon: ' + match.group('icon') + ' description: ' + match.group('desc')
    day3.temperature_high(match.group('max'))
    day3.temperature_low(match.group('min'))
    day3.wind_speed(match.group('speed'), 'mph')
    day3.wind(match.group('wind'))
    day3.visibility(match.group('visib'))
    day3.pressure(match.group('pressu'))
    day3.humidity(match.group('humidi'))

p_5day = r'''(?isx)
day \s five\s///////\s-->.*?<strong>(?P<day>.\w{2})
.*? strong&gt;(?P<desc>.*?)&lt;/strong
.*? fiveday_sym/(?P<icon>\d+).gif
.*? <strong>(?P<max>[\d/-]+) <abbr \s title="Day .*? <strong>(?P<min>[\d/-]+) <abbr \s title="Night
.*? /wind/v_(?P<wind>\w+).gif  .*? "Miles \s per \s hour">(?P<speed>\d+)
.*? "Visibility">(?P<visib>[^<]+) < .*? Millibars">(?P<pressu>\d+) < .*? percent">(?P<humidi>\d+)<
'''
match = re.search(p_5day, data1)
if match:
    day4 = weather.Forecast(match.group('day'))
    now.add_forecast(day4)
    day4.icon(iconmap[match.group('icon')])
    day4.sky(match.group('desc').replace('.',''))
    print 'day4: icon: ' + match.group('icon') + ' description: ' + match.group('desc')
    day4.temperature_high(match.group('max'))
    day4.temperature_low(match.group('min'))
    day4.wind_speed(match.group('speed'), 'mph')
    day4.wind(match.group('wind'))
    day4.visibility(match.group('visib'))
    day4.pressure(match.group('pressu'))
    day4.humidity(match.group('humidi'))

if len(now.forecasts) == 0:
        print "Can not parse forecast - day1"


print now
print 'fore------------------------------'
print today
print day1
print day2
print day3
print day4
print '------------------------------fore'

