#!/usr/bin/python

from qt import *
from lwp_config import *
import sys
import os
from gettext import GNUTranslations
from StringIO import StringIO
import gettext
from ConfigParser import RawConfigParser


if __name__ == "__main__":
    

    home_directory = os.popen("echo $HOME").readline()[0:-1]
    config_directory = home_directory + '/.superkaramba/lwp'
    #try:
    config = RawConfigParser()
    config.read(config_directory + '/lwp_gui_config')
    webcams = []
    weburls = []
    labsfile = open(config_directory + '/cam_labs','w')
    urlsfile = open(config_directory + '/cam_urls','w')
    if len(config.options('WebcamLabels')) > 0:
        for i in range(len(config.options('WebcamLabels'))):
            webcams.append(config.get('WebcamLabels','wclabel' + str(i)))
            weburls.append(config.get('WebcamURLs','wcurls' + str(i)))
        for i in webcams:
            labsfile.write(i + '\n')
        for i in weburls:
            urlsfile.write(i + '\n')
    labsfile.close()
    urlsfile.close()
    colourlist = ['main_red','main_green','main_blue','panel_red','panel_green','panel_blue']
    colourfile = open(config_directory + '/colours','w')
    for i in colourlist:
        colourfile.write(config.get('Main',i) + '\n')
    colourfile.close()
    app = QApplication(sys.argv)
    f = lwp_config()
    f.app_icons_list.insertItem('Liquid')
    f.app_icons_list.insertItem('Umicons')
    f.general_units_metric.setChecked(config.getint('Main','metric'))
    f.general_units_24.setChecked(config.getint('Main','24hour'))
    if config.getint('Main','update') == 0:
        f.general_update_1hr.setChecked(1)
    elif config.getint('Main','update') == 1:
        f.general_update_2hr.setChecked(1)
    else:
        f.general_update_3hr.setChecked(1)
    f.general_misc_kxdocker.setChecked(config.getint('Main','kxdocker'))
    f.general_misc_city.setChecked(config.getint('Main','dnamobst'))
    if config.getint('Main','wind') == 0:
        f.general_wind_from.setChecked(1)
    else:
        f.general_wind_to.setChecked(1)
    for i in webcams:
        f.webcams_current_list.insertItem(str(i))
        f.webcams_remove_list.insertItem(str(i))
    f.app_anim_disable.setChecked(config.getint('Main','animation'))
    f.app_anim_list.setCurrentItem(config.getint('Main','animstyle'))
    if config.get('Main','icondir') != 'NoDir':
        f.app_icons_filepath.setText(config.get('Main','icondir'))
        for i in os.listdir(config.get('Main','icondir')):
            if os.path.isdir(config.get('Main','icondir') + '/' + i) == 1:
                test_valid = 0
                for j in os.listdir(config.get('Main','icondir') + '/' + i):
                    if j == 'large_icons':
                        test_valid += 1
                if test_valid > 0:
                    f.app_icons_list.insertItem(i)
    if config.get('Main','bkgd_dir') != 'NoDir':
        f.app_bkgd_filepath.setText(config.get('Main','bkgd_dir'))
        for i in os.listdir(config.get('Main','bkgd_dir')):
            if os.path.isdir(config.get('Main','bkgd_dir') + '/' + i) == 1:
                test_valid = 0
                for j in os.listdir(config.get('Main','bkgd_dir') + '/' + i):
                    if j == 'bg.png':
                        test_valid += 1
                if test_valid > 0:
                    f.app_bkgd_list.insertItem(i)
    f.fonts_options_shadows.setChecked(config.getint('Main','shadow'))
    #if config.getint('Main','font_range') == 1:
        #f.fonts_options_narrow.setChecked(1)
    colour_main = QColor(config.getint('Main','main_red'),config.getint('Main','main_green'),config.getint('Main','main_blue'))
    splotch = QPixmap(40,14,-1)
    splotch.fill(colour_main)
    f.fonts_colours_main.setPixmap(splotch)
    colour_panel = QColor(config.getint('Main','panel_red'),config.getint('Main','panel_green'),config.getint('Main','panel_blue'))
    splotch = QPixmap(40,14,-1)
    splotch.fill(colour_panel)
    f.fonts_colours_panels.setPixmap(splotch)
    f.app_icons_list.setCurrentText(config.get('Main','iconset'))
    f.app_bkgd_list.setCurrentText(config.get('Main','bkgd_set'))
    #bkgd_list = ["bg0.png","bg1.png","bg2.png","bg3.png","bg4.png","bg5.png","bg6.png","bg7.png","bg8.png","bg9.png","bg10.png","bg16.png","bg11.png","bg12.png","bg13.png","bg14.png","bg15.png","bg17.png","bg21.png","bg22.png","bg24.png","bg23.png","bg20.png","bg25.png","bg18.png","bg19.png"]
    #current_bkgd = bkgd_list.index(config.get('Main','mainback'))
    #f.app_bkgd_list.setCurrentItem(int(current_bkgd))
    f.location_curr_loc.setText(config.get('Main','city'))
    f.location_curr_code.setText(config.get('Main','code'))

    # DAVE
    locations = config.items('Locations')
    numLocs = len(locations) / 2
    f.savedCodes = {}
    f.cityList = []
    for i in range(1,numLocs+1):
        cityOpt = 'city' + str(i)
        codeOpt = 'code' + str(i)
        cityName = config.get('Locations',cityOpt)
        codeVal = config.get('Locations',codeOpt)
        f.location_saved_list.insertItem(cityName)
        #f.location_saved_list.insertItem(codeVal)
        f.savedCodes[cityName] = codeVal
        f.cityList.append(cityName)
                                             
    trans_list=['bg','ca','cs','da','de','None','es','fi','fr','hu','it','nl','pl','pt','pt_br', 'ro','ru','sk','sl','sr','sr@Latn','sv','tr']
    path_file = open(config_directory + '/theme_path','r')
    theme_path = path_file.readlines()
    print theme_path
    for i in range(len(theme_path)):
        theme_path[i] = theme_path[i].replace('\n','')
    path_file.close()
    if theme_path[2] == 'no_lang':
        language = 'None'
    else:
        language = theme_path[2]
    current_trans= trans_list.index(str(language))
    f.general_trans_choose.setCurrentItem(int(current_trans))
    f.app_textanim_list.setCurrentItem(config.getint('Main','text_animstyle'))
    f.app_anim_delay.setValue(config.getfloat('Main','animdelay'))
    f.fonts_select_main_text.setText(config.get('Fonts','temp_family') + ', ' + config.get('Fonts','temp_size'))
    f.fonts_select_sky_text.setText(config.get('Fonts','sky_family') + ', ' + config.get('Fonts','sky_size'))
    f.fonts_select_det_text.setText(config.get('Fonts','detail_family') + ', ' + config.get('Fonts','detail_size'))
    f.fonts_select_pan_text.setText(config.get('Fonts','panel_family') + ', ' + config.get('Fonts','panel_size'))
    f.fonts_select_hour_text.setText(config.get('Fonts','hour_family') + ', ' + config.get('Fonts','hour_size'))
    f.show()
    app.setMainWidget(f)
    app.exec_loop()
